SystemOrganization addCategory: #'SUML-ModelExample'!

Object subclass: #Mission
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-ModelExample'!

Mission subclass: #BecomeALegend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-ModelExample'!

!BecomeALegend methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:41'!
canUsePirate: aPirate
	^(super canUsePirate: aPirate) & aPirate hasMoreItemsThan: 10.! !

!Mission methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:40'!
canUsePirate: aPirate
	^ aPirate isDrunkEnough! !

Mission subclass: #TreasureQuest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-ModelExample'!

!TreasureQuest methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:42'!
canUsePirate: aPirate
	^(super canUsePirate: aPirate) & (aPirate includesItem: #islandMap) & (aPirate includesItem: #compass).! !

Object subclass: #Pirate
	instanceVariableNames: 'items alcoholLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-ModelExample'!

!Pirate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:44'!
alcoholLevel: aNumber
	alcoholLevel := aNumber ! !

!Pirate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:43'!
includesItem: anItem
	^ items includes: anItem ! !

!Pirate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:43'!
isDrunkEnough 
	^ alcoholLevel > 0.5! !

!Pirate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:39'!
isUsefulForTheMission: aMission
	^ aMission canUsePirate: self! !

!Pirate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:38'!
items: aCollection
	items := aCollection! !

Object subclass: #Ship
	instanceVariableNames: 'mission tripulation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUML-ModelExample'!

!Ship methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 07:04'!
acceptIntoTripulation: aPirate
	(aPirate isUsefulForTheMission: mission)
		ifTrue: [tripulation add: aPirate].
	tripulation anySatisfy: [:p | p isDrunkEnough ]! !

!Ship methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:48'!
canPerformMission
	self flag: #todo.
	^ self tripulationIsBigEnough & (mission canBeAccomplishedBy: self)! !

!Ship methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:49'!
initialize 
	tripulation := Set new.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 5/6/2012 04:52'!
mission: aMission
	mission := aMission ! !
